// SpinEditCtrlView.cpp : implementation of the CSpinEditCtrlView class
//

#include "stdafx.h"
#include "SpinEditCtrl.h"

#include "SpinEditCtrlDoc.h"
#include "SpinEditCtrlView.h"
#include "spinedit.h"
#include "spindlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSpinEditCtrlView

IMPLEMENT_DYNCREATE(CSpinEditCtrlView, CView)

BEGIN_MESSAGE_MAP(CSpinEditCtrlView, CView)
	//{{AFX_MSG_MAP(CSpinEditCtrlView)
	ON_COMMAND(ID_SPIN_DYNAMIC, OnSpinDynamic)
	ON_COMMAND(ID_SPIN_DLG, OnSpinDlg)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpinEditCtrlView construction/destruction

CSpinEditCtrlView::CSpinEditCtrlView()
{
	// TODO: add construction code here
	m_pSpinEdit = NULL;
}

CSpinEditCtrlView::~CSpinEditCtrlView()
{
	if( m_pSpinEdit != NULL )
		delete m_pSpinEdit;
}

BOOL CSpinEditCtrlView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSpinEditCtrlView drawing

void CSpinEditCtrlView::OnDraw(CDC* pDC)
{
	CSpinEditCtrlDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CSpinEditCtrlView printing

BOOL CSpinEditCtrlView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSpinEditCtrlView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSpinEditCtrlView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CSpinEditCtrlView diagnostics

#ifdef _DEBUG
void CSpinEditCtrlView::AssertValid() const
{
	CView::AssertValid();
}

void CSpinEditCtrlView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSpinEditCtrlDoc* CSpinEditCtrlView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSpinEditCtrlDoc)));
	return (CSpinEditCtrlDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSpinEditCtrlView message handlers

void CSpinEditCtrlView::OnSpinDynamic() 
{
	// TODO: Add your command handler code here
	if( m_pSpinEdit != NULL )return;

	m_pSpinEdit = new CSpinEdit;
	CRect rect(100,100,300,130);
	m_pSpinEdit->Create( this, rect, ID_SPINEDIT, WS_VISIBLE );
	m_pSpinEdit->SetParams( SE_DOUBLE, 2, 0, 0, 0, 100, 0.01, TRUE, "example" );
}

void CSpinEditCtrlView::OnSpinDlg() 
{
	// TODO: Add your command handler code here
	CSpinDlg sd;
	if( sd.DoModal() == IDOK )
	{
		if( m_pSpinEdit != NULL )
		{
			double dbLower, dbUpper;
			sd.m_SpinEdit.GetRange( dbLower, dbUpper );
			m_pSpinEdit->SetParams( sd.m_SpinEdit.GetValueType(),
									sd.m_SpinEdit.GetValuePos(),
									sd.m_SpinEdit.GetCurValue(),
									sd.m_SpinEdit.GetBase(),
									dbLower, dbUpper, 
									sd.m_SpinEdit.GetStep(),
									sd.m_SpinEdit.GetNeedExtraText(),
									sd.m_SpinEdit.GetExtraText() );			
		}
	}
}
